import numpy as np
import cv2
import matplotlib
from matplotlib import pyplot as plt

MIN_MATCH_COUNT = 30 # search for the template whether there are tat least MIN_MATCH_CURENT godd matches in the scene
MIN_MATCH_CURRENT = 10 #stop when your matched homography has less than that features


img1 = cv2.imread('../data/scene3/emirates-logo.png', 0) # template
img2 = cv2.imread('../data/scene3/pressAds.png', 0)  # testImage

plt.imshow(img1, 'gray'), plt.title('template'),plt.show()
plt.imshow(img2, 'gray'), plt.title('image'),plt.show()

#%%  Initiate SIFT detector
sift = cv2.xfeatures2d.SIFT_create()
# find the keypoints and descriptors with SIFT from the template
kp1, des1 = #TODO, check methods of sift object
# kp1 list of keypoints kp1[0].pt = location, kp1[0].angle = orientation kp[0].octave provide scale information
print('des1.shape = ', str(des1.shape))
print('found ' + str(len(kp1)) + ' keypoints in image 1')

kp2, des2  = #TODO
print('found ' + str(len(kp2)) + ' keypoints in image 2')

#%% Initialize a FLANN object to match keypoint con il nearest neighborhood. 

# = This comes from FLANN documentation ============================================================================
# 	FLANN_INDEX_LINEAR = 0,
# 	FLANN_INDEX_KDTREE = 1,
# 	FLANN_INDEX_KMEANS = 2,
# 	FLANN_INDEX_COMPOSITE = 3,
# 	FLANN_INDEX_KDTREE_SINGLE = 4,
# 	FLANN_INDEX_HIERARCHICAL = 5,
# 	FLANN_INDEX_LSH = 6,
# 	FLANN_INDEX_KDTREE_CUDA = 7, // available if compiled with CUDA
# 	FLANN_INDEX_SAVED = 254,
# 	FLANN_INDEX_AUTOTUNED = 255,
# =============================================================================

FLANN_INDEX_KDTREE = 1

index_params = dict(algorithm=FLANN_INDEX_KDTREE, trees=5)
search_params = dict(checks=50)
flann = cv2.FlannBasedMatcher(index_params, search_params)

#%% find correspondences by matching the image features with the template features, 
# note it is not the same as matching des1 with des2!
# invoke flann methods to obtain 2 outputs: both the first and the second match for each feature in img2

matches =  #there is no trehsold, the closest point is returned.
# For each feature in the des2 image returns the two closest features in the first
print('found ' + str(len(matches)) + ' putative matches')
 

#%% 

# store all the good matches as per Lowe's ratio test.
good = []
# Need to draw only good matches, so create a mask, each row corresponds to a match
matchesMask = [[0,0] for i in iter(range(len(matches)))]

# the ratio test removes the ambiguous and false matches 
# keep only matches where the distance with the cloesest match is lower 
# than 0.8 * the distance with the second best match
for i,(m,n) in enumerate(matches):
    # implement ratio test check and in case it passes, use the following instructions
        good.append(m)
        matchesMask[i]=[1,0]
       
print('found ' + str(len(good)) + ' matches validated by the distance ratio test')
print('type(good) = ' + str(type(good)))

# plot all the good matches
draw_params = dict(matchColor = (0,255,0),
                   singlePointColor = (255,0,0),
                   matchesMask = matchesMask,
                   flags = 0)
img3 = cv2.drawMatchesKnn(img2, kp2, img1, kp1, matches,None,**draw_params)

matplotlib.rcParams["figure.figsize"]=(15,12)
plt.imshow(img3, 'gray'), plt.title('all matches after ratio test'),plt.show()

#%% cluster good matches by fitting homographies through RANSAC

    #TODO 1: find the first match in the scene
    #TODO 2: iteratively look for all the matches until there are not les than 
    #        MIN_MATCH_COUNT matches or you find a cluster which has less than MIN_MATCH_CURRENT = 10 

    # the feature m.queryIdx inside img1 has been matched with feature m.trainIdx inside img2
    src_pts = np.float32([kp1[m.trainIdx].pt for m in good]).reshape(-1, 1, 2)
    dst_pts = np.float32([kp2[m.queryIdx].pt for m in good]).reshape(-1, 1, 2)

    # RANSAC to fit homograpy: M is the final homography, mask represent the inliers
    M, mask = #TODO use cv2.findHomography 
    
    # TODO: control whether the homography is non-degenerate
    
    # this is a list containing all the inliers
    matchesMask = mask.ravel().tolist()
 
    # draw the rectangle in the scene corresponding to the estimated homography
    h, w = img1.shape
    pts = np.float32([[0, 0], [0, h - 1], [w - 1, h - 1], [w - 1, 0]]).reshape(-1, 1, 2)
    dst = cv2.perspectiveTransform(pts, M)
    img2 = cv2.polylines(img2, [np.int32(dst)], True, 255, 3, cv2.LINE_AA)
    
    
    # TODO check whether to continue
 
    
    # draw clustered matches, i.e. all the inliers for the selceted homography
    draw_params = dict(matchColor=(0, 255, 0),  # draw matches in green color
           singlePointColor=None,
               matchesMask=matchesMask,  # draw only inliers
           flags=2)
    img3 = cv2.drawMatches(img2, kp2, img1, kp1, good, None, **draw_params)
    
    matplotlib.rcParams["figure.figsize"]=(15,12)
    plt.imshow(img3, 'gray'), plt.show()
    
    #TODO: remove matched features 
    
    print('There remains: ' + str(len(good)) + ' features')
   
#else:
#    print("Not enough matches are found - {}/{}".format(len(good), MIN_MATCH_COUNT))
#   matchesMask = None

#%% 

